/// <reference types="bunyan" />
import { PubSubEngine } from 'graphql-subscriptions/dist/pubsub-engine';
import * as Logger from 'bunyan';
export declare class PubSubAsyncIterator<T> implements AsyncIterator<T> {
    private pullQueue;
    private pushQueue;
    private eventsArray;
    private allSubscribed;
    private listening;
    private pubsub;
    private logger;
    constructor(pubsub: PubSubEngine, eventNames: string | string[], logger?: Logger);
    next(): Promise<{}>;
    return(): Promise<{
        value: any;
        done: boolean;
    }>;
    throw(error: any): Promise<never>;
    private pushValue(event);
    private pullValue();
    private emptyQueue(subscriptionIds);
    private subscribeAll();
    private unsubscribeAll(subscriptionIds);
}
